﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication1
{
    public partial class Form2 : Form
    {
        UltraGrid grid = new UltraGrid();

        public Form2()
        {
            InitializeComponent();

            grid.InitializeLayout += new InitializeLayoutEventHandler(UltraGrid1_InitializeLayout);
            grid.Dock = DockStyle.Fill;
            this.Controls.Add(grid);

            UseNewData();
        }

        private void UseNewData()
        {
            DataTable table = new DataTable();
            {
                Random r = new Random();
                string s1 = "Int1";
                string s2 = r.Next().ToString();
                string s3 = r.Next().ToString();
                string s4 = r.Next().ToString();

                table.Columns.Add(new DataColumn(s1, Type.GetType("System.String")));
                table.Columns.Add(new DataColumn(s2, Type.GetType("System.String")));
                table.Columns.Add(new DataColumn(s3, Type.GetType("System.String")));
                table.Columns.Add(new DataColumn(s4, Type.GetType("System.String")));
                DataRow row;
                row = table.NewRow();
                row[s1] = 0; row[s3] = "hello"; row[s4] = DateTime.Now.Second; row[s2] = 0;
                table.Rows.Add(row);
                row = table.NewRow();
                row[s1] = 1; row[s3] = "hello2"; row[s4] = DateTime.Now.Second; row[s2] = 1;
                table.Rows.Add(row);
                row = table.NewRow();
                row[s1] = 10; row[s3] = "hello3"; row[s4] = DateTime.Now.Second; row[s2] = 0;
                table.Rows.Add(row);
                for (int i = 0; i < 10; i++)
                {
                    row = table.NewRow();
                    row[s1] = i; row[s3] = "hello"; row[s4] = DateTime.Now.Second; row[s2] = 0;
                    table.Rows.Add(row);
                }
            }

            DataTable table2 = grid.DataSource as DataTable;
            grid.DataSource = null;
            if (table2 != null)
                table2.Dispose();

            GC.Collect();
            GC.WaitForPendingFinalizers();
            grid.DataSource = table;
        }

        private void buttonNewData_Click(object sender, EventArgs e)
        {
            UseNewData();
        }

        private void UltraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.FilterUIType = FilterUIType.FilterRow;
        }

    }
}
